local barLength = 128
local barWidth = 8
local barColorR 
local barColorG 
local barColorB 

local leftTimerFrame = CreateFrame("StatusBar", "LeftTimerFrame", SpellActivationOverlayFrame)
local rightTimerFrame = CreateFrame("StatusBar", "RightTimerFrame", SpellActivationOverlayFrame)
local topTimerFrame = CreateFrame("StatusBar", "TopTimerFrame", SpellActivationOverlayFrame)

leftTimerFrame:RegisterEvent("PLAYER_LOGIN")
leftTimerFrame:SetScript("OnEvent", function()
	local class = select(2,UnitClass("player"))

-- todo: costom color for every spell
	if class == "WARRIOR" then
		barColorR = 1
		barColorG = .2
		barColorB = .1
	elseif class == "MAGE" then
		barColorR = .4
		barColorG = .7
		barColorB = 1
	elseif class == "ROGUE" then
		barColorR = 1
		barColorG = .5
		barColorB = .1
	elseif class == "DRUID" then
		--good for shooting stars - balance - top
		barColorR = .7	
		barColorG = .5
		barColorB = 1

--[[    --good for omen of clarity/clearcasting - restoration - sides
		barColorR = .7	
		barColorG = 1
		barColorB = .1
--]]
	elseif class == "HUNTER" then
		barColorR = .7
		barColorG = .8
		barColorB = .2
	elseif class == "SHAMAN" then
		barColorR = .3
		barColorG = .4
		barColorB = 1
	elseif class == "PRIEST" then
		barColorR = 1
		barColorG = 1
		barColorB = .8
	elseif class == "WARLOCK" then
		barColorR = .4
		barColorG = .1
		barColorB = 1
	elseif class == "PALADIN" then
		barColorR = 1
		barColorG = .8
		barColorB = .1
	elseif class == "DEATHKNIGHT" then
		barColorR = .1
		barColorG = 1
		barColorB = 1
	elseif class == "MONK" then
		barColorR = .1
		barColorG = .9
		barColorB = .4

	end
	leftTimerFrame:SetStatusBarColor(barColorR,barColorG,barColorB)
	rightTimerFrame:SetStatusBarColor(barColorR,barColorG,barColorB)
	topTimerFrame:SetStatusBarColor(barColorR,barColorG,barColorB)
end)


leftTimerFrame:SetOrientation("VERTICAL")
leftTimerFrame:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
leftTimerFrame:SetRotatesTexture(true)
leftTimerFrame:SetPoint("RIGHT",SpellActivationOverlayFrame,"LEFT")
leftTimerFrame:SetSize(barWidth,barLength)
leftTimerFrame:Hide()

rightTimerFrame:SetOrientation("VERTICAL")
rightTimerFrame:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
rightTimerFrame:SetRotatesTexture(true)
rightTimerFrame:SetPoint("LEFT",SpellActivationOverlayFrame,"RIGHT")
rightTimerFrame:SetSize(barWidth,barLength)
rightTimerFrame:Hide()


topTimerFrame:SetPoint("BOTTOM",SpellActivationOverlayFrame,"TOP")
topTimerFrame:SetSize(barLength,barWidth)
topTimerFrame:SetStatusBarTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
topTimerFrame:Hide()

topTimerFrame:RegisterEvent("SPELL_ACTIVATION_OVERLAY_SHOW")
topTimerFrame:SetScript("OnEvent", function(self, event, ...)
	local overlayPosition = (select(3,...)) -- "Top", "Left + Right (Flipped)" , "Left" , "Right (Flipped)"

												--[[
												druid:restoration:Clearcasting: "Left + Right (Flipped)" triggered by spell "Omen of Clarity"
												warlock:demonology:Molten Core: "Left" at first stack, spellID = 122355 "Right (Flipped)" at 2 stacks, spellID = 126090 3+ does not trigger event
												]]
--[[debugging code
	print(" ")
	print("event = ",event)
	print("event arguments = " , ...)
	print("spell info = " , GetSpellInfo((...)))
	print("overlayPosition = " , overlayPosition)
--]]
	
	local spellID = (...)
	if spellID == 93426 then	--Dark Transformation
		spellID = 49572		--Shadow Infusion
	end
								--[[
									122355 Moltec Core (1 stack)
									126090 Moltec Core (2 stacks)
								]]


	local spellName = GetSpellInfo(spellID)
	local spellDuration = (select(6, UnitBuff("player",spellName) ))
--[[debugging code
		print("UnitBuff = " , UnitBuff("player",spellName))
--]]

	if spellDuration and spellID ~= 126090 then 					--Molten Core 2 stacks
--[[ debugging code
		print("spellName = " .. spellName,  "spellDuration = " , spellDuration)
--]]

		if overlayPosition == "Top" then
			startTimer(topTimerFrame, spellName, spellDuration)

		elseif overlayPosition == "Left + Right (Flipped)" then
			startTimer(leftTimerFrame, spellName, spellDuration)
			startTimer(rightTimerFrame, spellName, spellDuration)
		elseif overlayPosition == "Left" then
			startTimer(leftTimerFrame, spellName, spellDuration)
		elseif overlayPosition == "Right (Flipped)" then
			startTimer(rightTimerFrame, spellName, spellDuration)
		end

	end
end)


function startTimer(timerFrame, spellName, spellDuration)
	timerFrame:SetMinMaxValues(0, spellDuration )
	timerFrame:Show()
	timerFrame:SetScript("OnUpdate",function()
		if UnitBuff("player", spellName) == nil then
			timerFrame:Hide()
			timerFrame:SetScript("OnUpdate",function() end)
		else
			local spellExpiration = (select(7, UnitBuff("player",spellName) ))
			timerFrame:SetValue(spellExpiration -GetTime())
		end
	end)
end



